# OctaneRender for Poser: Create Emitter From Lights
# 
# Copyright (c) 2012, Paul Kinnane, Physicalc Software Pty Ptd
#
# For additional support, contact Paul Kinnane at support@physicalc-software.com
#
# Version 1.0 - original release
#
# Version 1.02q - infinite lights now no longer converted - since they will feed the Octane dayilght system instead
#
#========================================================================================================================================
import poser

print 
print "Deleting existing emitter props"
for p in poser.Scene().Actors():
   if (p.IsProp()):
        if string.find(p.Name(), "emitterprop_") != -1:
            poser.Scene().SelectActor(p)
            poser.Scene().DeleteCurrentProp()

for light in poser.Scene().Lights():
    if light.LightOn() == True:
        emitterName = "emitterprop_" + light.Name()
        if light.LightType() == poser.kLightCodeIMAGE:
            print "Ignoring IBL light : " + light.Name()
        elif light.LightType() == poser.kLightCodeINFINITE:
            print "Ignoring Infinite light : " + light.Name()
#            print "Creating emitter prop for infinite light : " + light.Name()
#            poser.Scene().LoadLibraryProp("/Runtime/Libraries/Props/Primitives/one sided square.ppz")
#            newProp = poser.Scene().CurrentActor()
#            newProp.SetName(emitterName)
#            newProp.SetParent(light, 0, 1)
#            newProp.ParameterByCode (poser.kParmCodeASCALE).SetValue(200)
#            newProp.ParameterByCode (poser.kParmCodeXTRAN).SetValue(0)
#            newProp.ParameterByCode (poser.kParmCodeZTRAN).SetValue(10)
#            newProp.ParameterByCode (poser.kParmCodeYTRAN).SetValue(0)
#            newProp.ParameterByCode (poser.kParmCodeXROT).SetValue(180)
#            newProp.ParameterByCode (poser.kParmCodeZROT).SetValue(0)
#            newProp.ParameterByCode (poser.kParmCodeYROT).SetValue(0)
#            r, g, b = light.ParameterByCode (poser.kParmCodeKDRED).Value(), light.ParameterByCode (poser.kParmCodeKDGREEN).Value(), light.ParameterByCode (poser.kParmCodeKDBLUE).Value()
#            intensity = (r + g + b) / 3 * light.ParameterByCode (poser.kParmCodeKDINTENSITY).Value()
#            material = newProp.Material("Preview")
#            shaderTree = material.ShaderTree()
#            shaderTree.Nodes()[0].InputByInternalName("Ambient_Color").SetColor(1, 1, 1)
#            shaderTree.Nodes()[0].InputByInternalName("Ambient_Value").SetFloat(intensity * 200)
#            shaderTree.UpdatePreview()
        elif light.LightType() == poser.kLightCodePOINT:
            print "Creating emitter prop for point light : " + light.Name()
            #poser.Scene().LoadLibraryProp("/Runtime/Libraries/Props/Primitives/Ball Hi-Res.ppz")
            poser.Scene().LoadLibraryProp("/Runtime/Libraries/Props/Primitives/Ball.ppz")
            newProp = poser.Scene().CurrentActor()
            newProp.SetName(emitterName)
            newProp.SetParent(light, 0, 1)
            newProp.ParameterByCode (poser.kParmCodeXTRAN).SetValue(0)
            newProp.ParameterByCode (poser.kParmCodeZTRAN).SetValue(0)
            newProp.ParameterByCode (poser.kParmCodeYTRAN).SetValue(0)
            newProp.ParameterByCode (poser.kParmCodeXROT).SetValue(0)
            newProp.ParameterByCode (poser.kParmCodeZROT).SetValue(0)
            newProp.ParameterByCode (poser.kParmCodeYROT).SetValue(0)
            r, g, b = light.ParameterByCode (poser.kParmCodeKDRED).Value(), light.ParameterByCode (poser.kParmCodeKDGREEN).Value(), light.ParameterByCode (poser.kParmCodeKDBLUE).Value()
            intensity = (r + g + b) / 3 * light.ParameterByCode (poser.kParmCodeKDINTENSITY).Value()
            material = newProp.Material("Preview")
            shaderTree = material.ShaderTree()
            shaderTree.Nodes()[0].InputByInternalName("Ambient_Color").SetColor(1, 1, 1)
            shaderTree.Nodes()[0].InputByInternalName("Ambient_Value").SetFloat(intensity * 300)
            shaderTree.UpdatePreview()
        elif light.LightType() == poser.kLightCodeSPOT:
            print "Creating emitter prop for spot light : " + light.Name()
            #poser.Scene().LoadLibraryProp("/Runtime/Libraries/Props/Primitives/Square Hi-Res.ppz")
            poser.Scene().LoadLibraryProp("/Runtime/Libraries/Props/Primitives/one sided square.ppz")            
            newProp = poser.Scene().CurrentActor()
            newProp.SetName(emitterName)
            newProp.SetParent(light, 0, 1)
            newProp.ParameterByCode (poser.kParmCodeXTRAN).SetValue(0)
            newProp.ParameterByCode (poser.kParmCodeZTRAN).SetValue(0)
            newProp.ParameterByCode (poser.kParmCodeYTRAN).SetValue(0)
            #newProp.ParameterByCode (poser.kParmCodeXROT).SetValue(-90)
            newProp.ParameterByCode (poser.kParmCodeXROT).SetValue(180)
            newProp.ParameterByCode (poser.kParmCodeZROT).SetValue(0)
            newProp.ParameterByCode (poser.kParmCodeYROT).SetValue(0)
            r, g, b = light.ParameterByCode (poser.kParmCodeKDRED).Value(), light.ParameterByCode (poser.kParmCodeKDGREEN).Value(), light.ParameterByCode (poser.kParmCodeKDBLUE).Value()
            intensity = (r + g + b) / 3 * light.ParameterByCode (poser.kParmCodeKDINTENSITY).Value()
            material = newProp.Material("Preview")
            shaderTree = material.ShaderTree()
            shaderTree.Nodes()[0].InputByInternalName("Ambient_Color").SetColor(1, 1, 1)
            shaderTree.Nodes()[0].InputByInternalName("Ambient_Value").SetFloat(intensity * 300)
            shaderTree.UpdatePreview()

print "Finished"            
poser.Scene().DrawAll()
