# OctaneRender for Poser: Sene Texture Counter
# 
# Copyright (c) 2012, Paul Kinnane, Physicalc Software Pty Ptd
#
# For additional support, contact Paul Kinnane at support@physicalc-software.com
#
# Version 1.0 - original release
#
#========================================================================================================================================
import poser
import wx

print
print "OctaneRender for Poser : Scene Texture Count analysis"
print "----------------------"

TotalTextureMaps = 0
TotalBumpMaps = 0
TotalMemory = 0.0
TotalPolygons = 0

GlobalRGBFileList = []
GlobalGrayscaleFileList = []

def printImage(fName, type):
    global TotalMemory, GlobalRGBFileList, GlobalGrayscaleFileList
    nolog = wx.LogNull() 
    image = wx.Image(fName)
    del nolog 
    fullName = fName
    if string.rfind(fName, "\\") != -1:
        fName = fName[string.rfind(fName, "\\") + 1:]
    size = float(max(image.GetWidth(), image.GetHeight()))
    if type == "Bump" or type == "Trans":
        size = size * size * 1.0
        if fullName not in GlobalGrayscaleFileList:
            GlobalGrayscaleFileList.append(fullName)
            TotalMemory += size
    else:    
        size = size * size * 4.0
        if fullName not in GlobalRGBFileList:
            GlobalRGBFileList.append(fullName)
            TotalMemory += size
    
    print "   - " + fName + " (" + str(image.GetWidth()) + " x " + str(image.GetHeight()) + " = " + str(round(size/1024.0/1024.0,1)) + "MB) " + type 
    #print len(image.GetData())

if poser.Scene().Figures() != None:
    for figure in poser.Scene().Figures():
        if figure.Visible() == 1:
            textureList = []
            bumpList = []
            print "Figure : " + figure.Name()
            try:
                if figure.Materials() != None:
                    for material in figure.Materials():
                        if material.TextureMapFileName() != None:
                            if material.TextureMapFileName() not in textureList:
                                textureList.append(material.TextureMapFileName())
                                printImage(material.TextureMapFileName(), "Diffuse")
                        if material.BumpMapFileName() != None:
                            if material.BumpMapFileName() not in bumpList:
                                bumpList.append(material.BumpMapFileName())            
                                printImage(material.BumpMapFileName(), "Bump")
                        if material.TransparencyMapFileName() != None:
                            if material.TransparencyMapFileName() not in textureList:
                                textureList.append(material.TransparencyMapFileName())
                                printImage(material.TransparencyMapFileName(), "Trans")
            except:
                pass
            numBumpMaps = 0
            for m in bumpList:
                if m not in textureList:
                    numBumpMaps += 1
            print "* Num Texture/Trans Maps : " + str(len(textureList))
            print "* Num Bump Maps : " + str(numBumpMaps)
            TotalTextureMaps += len(textureList)
            TotalBumpMaps += numBumpMaps
            print "----------------------"
        #else:
        #    print "Ignoring invisible figure : " + figure.Name()
        #    print "----------------------"

if poser.Scene().Actors() != None:       
    for prop in poser.Scene().Actors():
        if prop.IsProp():
            if prop.Visible() == 1:
                if prop.IsDeformer() == 0 and prop.IsBase() == 0 and prop.IsZone() == 0 and prop.IsLight() == 0 and prop.Geometry() != None and prop.IsCamera() == 0 and prop.Visible() == 1 and prop.Name() not in ["FocusDistanceControl", "GoalCenterOfMass"]:
                    textureList = []
                    bumpList = []
                    print "Prop : " + prop.Name()
                    try:
                        if prop.Materials() != None:
                            for material in prop.Materials():
                                shaderTree = material.ShaderTree()
                                amValue = shaderTree.Nodes()[0].InputByInternalName("Ambient_Value").Value()
                                amColor = shaderTree.Nodes()[0].InputByInternalName("Ambient_Color").Value()
                                if amValue > 1 and amColor != [0, 0, 0]:
                                    print "   * Material " + material.Name() + " is an EMITTER (has an Ambient_Value > 1)"
                                if material.TextureMapFileName() != None:
                                    if material.TextureMapFileName() not in textureList:
                                        textureList.append(material.TextureMapFileName())
                                        printImage(material.TextureMapFileName(), "Diffuse")
                                if material.BumpMapFileName() != None:
                                    if material.BumpMapFileName() not in bumpList:
                                        bumpList.append(material.BumpMapFileName())
                                        printImage(material.BumpMapFileName(), "Bump")            
                                if material.TransparencyMapFileName() != None:
                                    if material.TransparencyMapFileName() not in textureList:
                                        textureList.append(material.TransparencyMapFileName())
                                        printImage(material.TransparencyMapFileName(), "Trans")
                    except:
                        pass
                    numBumpMaps = 0
                    for m in bumpList:
                        if m not in textureList:
                            numBumpMaps += 1
                    print "* Num Texture/Trans Maps : " + str(len(textureList))
                    print "* Num Bump Maps : " + str(numBumpMaps)
                    TotalTextureMaps += len(textureList)
                    TotalBumpMaps += numBumpMaps
                    print "----------------------"
            #else:
            #    print "Ignoring invisible prop : " + prop.Name()
            #    print "----------------------"
        
print "Total Num Texture Maps (rgb) : " + str(len(GlobalRGBFileList))
print "Total Num Bump/Trans Maps (grayscale) : " + str(len(GlobalGrayscaleFileList))
print "Total Memory Required for Textures : " + str(round(TotalMemory / 1024.0 / 1024.0, 1)) + "MB  (assumes only LDR textures)"
print "----------------------"
print "Finished.  Note: 'Num Bump Maps' excludes bump maps that were counted in the Texture/Trans Maps count"            